#
# WorkBench for newspro
# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
#
$wbBuild = 11;

#
# Declare fields for UserGroups
#	WBDIR : a list of directories and their properties
#	WBTXC : colors for WorkBench
#	WBFVS : folder view settings
#
$uField{'WBDIR'} = q~User Directories~;
$gField{'WBDIR'} = q~Group Directories~;
$uField{'WBTXC'} = q~User Text Color~;
$gField{'WBTXC'} = q~Group Text Color~;
$uField{'WBFVS'} = q~Folder View Settings~;
$ugGetProperty{'WBDIR'} = q~ugGetProperties~;

# Set minimum user level editing permissions
# for workbench settings:
#	level 1 users may edit their own settings
#	level 3 users may edit all group settings
#
$uMinEditLevel{'WBDIR'} = 1;
$gMinEditLevel{'WBDIR'} = 3;
$uMinEditLevel{'WBTXC'} = 1;
$gMinEditLevel{'WBTXC'} = 3;
$uMinEditLevel{'WBFVS'} = 1;

##
## for build 28 of newspro.cgi & nplib.pl
##
&CheckBuild( 28, 'WorkBench', 'npa_workbench.pl' );

push(@Addons_Loaded, qq~Workbench build $wbBuild~);
push(@Addons_PreHeader, 'WorkBenchPreLoad');
push(@Addons_MainPage, 'WorkBench_MainPage');
push(@Addons_NPHTMLFoot, 'WorkBench_HTMLFoot');
$Addons_List{'WorkBench 1.0'} = ['npa_workbench.pl', 'Build 9 From Outer Space.'];


##############################################
# Make sure UserGroups loads.
# also split this user's workbench color settings up.
#	invocation: &WorkBenchPreLoad();
#
sub WorkBenchPreLoad {
	&ugCheckBuild( 15, 'WorkBench', 'npa_workbench.pl' );
	if (query_string() =~ /wb(.*)/i ) {
		&UGStartup;
		@wbtxc = split( /\W/, $UGV_WBTXC );
		unless( @wbtxc == 11 ) {
			@wbtxc = ( 'ffc477', '77ff66', '262424', '7a7a7c', '4682b4', '6a5acd', 'ff0000', 'ffffff', '000000', '333333', '555555' );
		}
		# index 00 = text color
		# index 01 = icon name color
		# index 02 = table BG color
		# index 03 = table border color
		# index 04 = link color
		# index 05 = visited color
		# index 06 = active color
		# index 07 = hover color
		# index 08 = body color
		# index 09 = row color 1
		# index 10 = row color 2
		&WorkBenchMain( $1 );
	}
}

##############################################
# Print the WorkBench frames page.
#	invocation: &WorkBenchIndex();

#
sub WorkBenchIndex {
	print header();
	print qq~
<html>
<head>
	<title>$Messages{'NewsPro'}: WorkBench</title>
	$Messages{'ContentType'}
</head>

<frameset rows="*" cols="16%,*" border="5">
	<frame src="$scripturl?wbfolders" name="wbfolders" marginheight="0" marginwidth="0" framespacing=0>
	<frame src="$scripturl?wbdesktop" name="wbdesktop" marginheight="0" marginwidth="0" framespacing=0>
</frameset>

<noframes>
	<body bgcolor="#000000" text="#FFFFFF"><center>
	Apparently your browser doesn't support frames.
	You cannot use WorkBench. Sorry!
	</body>
</noframes>
</html>
	~;
	exit;
}

##############################################
# Print the WorkBench page header.
#	arguments: accepts title, background alignment, javascript code, and body tag argument
#	invocation: &WorkBenchHead( "title", "left/right", "<script>..</script>",q~onLoad="jsFunc()"~ );
#
sub WorkBenchHead {
	($wbtitle,$wbalignbg,$wbheadercode,$wb_body_declaration_tag) = @_;
	$wbtitle ||= "WorkBench";
	$wbalignbg ||= "left";
	if (@Addons_WBHeaderPre) {
		&RunAddons(@Addons_WBHeaderPre);
	}
	print header();
	print qq~
<html>
<head>
$Messages{'ContentType'}
<title>WorkBench: $wbtitle</title>
<style type="text/css">
<!--
A:link { color: #$wbtxc[4]; font-weight: normal; text-decoration: none; background: transparent }
A:visited { color: #$wbtxc[5]; font-weight: normal; text-decoration: none; background: transparent }
A:active { color: #$wbtxc[6]; font-weight: normal; text-decoration: none; background: transparent }
A:hover { color: #$wbtxc[7]; font-weight: normal; text-decoration: bold; background: transparent }
.wbbody { color: #$wbtxc[0]; background: url($UGV_WALL) #$wbtxc[8] repeat fixed top $alignbg }
.wbfilename { color: #$wbtxc[1]; background: transparent }
img { border: 0 }
-->
</style>
~;
	if (@Addons_WBHeader) {
		&RunAddons(@Addons_WBHeader);
	}
	print qq~
$wbheadercode
</head>
<body class="wbbody" bgcolor="#$wbtxc[8]" text="#$wbtxc[0]" link="#$wbtxc[4]" vlink="#$wbtxc[5]" alink="#$wbtxc[6]" $wb_body_declaration_tag>
<!--VirtualAvenueBanner-->
<!--#echo banner=""-->
~;
	if (@Addons_WBHeadBody) {
		&RunAddons(@Addons_WBHeadBody);
	}
}


##############################################
# Print the WorkBench page footer.
#	invocation: &WorkBenchFoot();
#
sub WorkBenchFoot {
	if (@Addons_WBFoot) {
		&RunAddons(@Addons_WBFoot);
	}
	print qq~
<table class="wbfoot" width="200" cellspacing="1" cellpadding="1" bgcolor="#$wbtxc[2]" border="3" bordercolor="#$wbtxc[3]" align="center">
<tr><td align="center">
WorkBench build $wbBuild<BR>
by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><BR>
<a href="http://www.wwddfd.com">plushpuffin's perl garden</a></td></tr></table>
</body></html>~;
}

##############################################
# Print the WorkBench folder-filters for this user and the group(s) s/he belongs to.
#	invocation: &WorkBenchFolders();
#
sub WorkBenchFolders {
	&WorkBenchHead('folders','right');
	print q~<table>~;
	&WBReadFolders( 1 );
	if (@Addons_WBFoldersPre) {
		&RunAddons(@Addons_WBFoldersPre);
	}
	WBFOLDERLOOP: for( $wbfoldernum = 0; $wbfoldernum < @wbdirlist; $wbfoldernum++ ) {
		( $wbdirname ) = $wbdirlist[$wbfoldernum] =~ m~(.+)=.*~;
		( $wbdirurl = $wbdirname ) =~ s/\s/%20/g;
		if (@Addons_WBFolders) {
			&RunAddons(@Addons_WBFolders);
		}
		print qq~
	<tr>
		<td>
			<a href="$scripturl?wbdesktop$wbdirurl" target="wbdesktop">
			<img border="0" src="wblib/ftv2folderclosed.gif"></a>
		</td>
		<td valign="top" class="wbfilename">
			$wbdirname
		</td>
	</tr>
~;
	}
	print q~</table>~;
	if (@Addons_WBFoldersPost) {
		&RunAddons(@Addons_WBFoldersPost);
	}
	print q~</body></html>~;
	exit;
}

##############################################
# Print the contents of the selected folder.
#	invocation: &WorkBenchDesktop( "folder name" );
#
sub WorkBenchDesktop {
	$wbcurdir = $_[0];
	&WBReadFolders( 1 );
	&WorkBenchHead('desktop','left');
	unless( $in{'delmul'} ) {
		&WorkBenchToolBar;
	}
	print qq~<div align="center"><h2 class="wbfoldername">$wbcurdir</h2></div><HR size="3">~ if( $wbcurdir );
	if( exists $wbdirhash{$wbcurdir} ) {
		&loadND;
		&WBLoadFolder($wbcurdir);
		( $wbfview, $wbfcol, @wbfvfield ) = split( /\W/, $UGV_WBFVS );
		$wbfview ||= 'DisplayNewsDetails';
		$wbfcol ||= 3;
		unless( @wbfvfield ) {
			@wbfvfield = qw/newssubject newsdate newsname/;
		}
		if (@Addons_WBDesktopPre) {
			&RunAddons(@Addons_WBDesktopPre);
		}
		@NewsItems = ();
		for( $newsnum = 0; $newsnum < @NewsData; $newsnum++ ) {
			unless ($up >= 2 || $NewsData[$newsnum]->{'newsname'} eq $Cookies{'uname'}) { next; }
			my $wbtest = 1;
			for( $wbfilternum = 0; $wbfilternum  < @wbdirfilter && $wbtest; $wbfilternum++ ) {
				#my $wbargs = join( ',', @{$wbdirfilter[$wbfilternum][1]} );
				#&WBMessage(qq~filter $wbfilternum running : $wbdirfilter[$wbfilternum][0] ( $wbargs )~);
				unless( scalar @{$wbdirfilter[$wbfilternum][1]} ) { next; }
				$wbtest = &{$wbdirfilter[$wbfilternum][0]}( @{$wbdirfilter[$wbfilternum][1]} );
			}
			if (@Addons_WBFilter) {
				&RunAddons(@Addons_WBDesktop);
			}
			if( $wbtest ) {
				push( @NewsItems, $newsnum );
			}
		}
		if (@Addons_WBFilterPost) {
			&RunAddons(@Addons_WBDesktopPost);
		}
		unless( @NewsItems ) {
			&WBMessage(qq~The folder you are viewing, $wbcurdir, does not contain any news items.<BR>
This probably means that your filters for this folder are either inaccurate or too strict.~);
		}
		else {
			print qq~<div align="center">
<form target="wbedit" action="$scripturl?wbeditmul" method="post">
<input type="hidden" name="wbcurdir" value="$wbcurdir">
~;
			&{$wbfview};
			print q~<BR><HR size="3">
<input type="submit" name="editmul" value="edit selected news items">
~;
			if( $in{'delmul'} ) {
				print q~<br>
<input type="checkbox" name="forcedelmul" value="1">YES, I AM SURE. DELETE SELECTED NEWS ITEMS.<br>
<input type="submit" name="delmul" value="Check the box and click here to confirm deletion.">~;
			}
			else {
				print q~<br>
<input type="submit" name="delmul" value="delete selected news items">~;
			}
			print q~</form></div>~;
		}
	}
	elsif( $wbcurdir ) {
		&WBMessage(qq~The folder specified, $wbcurdir, does not appear to exist.~);
	}
	else {
		&WBMessage(qq~No folder selected. You need to click a folder in the left-hand frame.<BR>
If there are no folders listed, you must either <a target="wbfolders" href="$scripturl?wbfolders">refresh</a> that frame or create a new folder in <a href="$scripturl?wbtbeaf">Manage Folders</a>~);
	}
	&WorkBenchFoot;
	exit;
}

##############################################
# Print the toolbar which appears at the top of every page.
#	invocation: &WorkBenchToolBar();
#
sub WorkBenchToolBar {
	print qq~<div align="center">
	<table class="wbtoolbar" width="70%" cellspacing="0" cellpadding="10" bgcolor="#$wbtxc[2]" border="1" bordercolor="#$wbtxc[3]" align="center"><tr><td width="100%" align="center">~;
	$wbdirurl = $wbcurdir;
	$wbdirurl =~ s/\s/%20/g;
	print qq~
	<a href="$scripturl?wbtbef$wbdirurl">Edit Current Folder</a>
	~ if( $wbcurdir );
	print qq~
	| <a href="$scripturl?wbtbeaf">Manage Folders</a>
	| <a href="$scripturl?wbes">Edit Settings</a>
	| <a href="$scripturl?submit" target="_top">Submit News</a>
	| <a href="$scripturl" target="_top">Back to NewsPro</a>
	~;
	if(@Addons_WBToolBar) {
		&RunAddons(@Addons_WBToolBar);
	}
	print qq~</td></tr></table></div><br>~;
}

##############################################
# Print a warning message in a table.
#	invocation: &WBMessage("message");
#
sub WBMessage {
	print qq~
	<table class="wbalert" width="85%" cellspacing="5" cellpadding="5" bgcolor="#$wbtxc[2]" border="1" bordercolor="#$wbtxc[3]" align="center">
<tr><td align="center">
	<h4>$_[0]</h4>
	</td></tr></table>
	~;
}

##############################################
# Manage the use of WorkBench.
#	invocation: &WBToolBarMain("query string for action");
#
sub WBToolBarMain {
	my $qstring = shift;
	my ( $wbdirselect, $ugselect, $ugchoice, %ugsel, @groups, $group );
	local $TBFootMessage;
	if( $in{'ugselect'} && $up > 2 ) {
		$ugchoice = $in{'ugselect'};
		unless( exists $CPassword{$ugchoice} || exists $usergroups{$ugchoice} ) {
			$ugchoice = '';
		}
	}
	$ugchoice ||= $Cookies{'uname'};
	$ugsel{$ugchoice} = 'selected';
	&WBReadFolders( 0, $ugchoice );
	foreach my $wbdirentry (keys %wbdirhash) {
		$wbdirselect .= qq~<option value="$wbdirentry">$wbdirentry</option>\n~;
	}
	@groups = sort keys %CPassword;
	foreach $group (sort keys %usergroups) {
		unless( $CPassword{$group} ) {
			push( @groups, $group );
		}
	}
	if( $up > 2 ) {
		$ugselect = '<select name="ugselect">\n';
		foreach $group (@groups) {
			$ugselect .= qq~<option value="$group" $ugsel{$group}>$group</option>\n~;
		}
	}
	else {
		$ugselect = qq~<input type="hidden" name="ugselect" value="">~;
	}
	if( $qstring =~ /^sf(.*)/i ) {
		$wbcurdir = $1 || $in{'editfolder'};
		unless( exists $wbdirhash{$wbcurdir} ) {
			&WBMessage(qq~The folder $wbcurdir does not exist for $ugchoice.~);
		}
		else {
			&WBLoadFolder( $wbcurdir );
			for( $wbfilternum = 0; $wbfilternum < @wbdirfilter; $wbfilternum++ ) {
				unless( $in{"fchk--$wbfilternum"} ) {
					splice( @wbdirfilter, $wbfilternum, 1 );
					next;
				}
				&{$WBFEdit{$wbdirfilter[$wbfilternum][0]}[1]}( @{$wbdirfilter[$wbfilternum][1]} );
			}
			if( $in{'newffilter'} ) {
				push( @wbdirfilter, [ $in{'newffilter'}, [] ] );
			}
			if( $in{'dirdesig'} && $in{'dirdesig'} ne $wbcurdir ) {
				delete $wbdirhash{$wbcurdir};
				$wbcurdir = $in{'dirdesig'};
				$jscode = q~
<SCRIPT LANGUAGE="JavaScript">
<!--
function go(frame1,page1) {
eval("parent."+frame1+".location='"+page1+"'");
}
//-->
</SCRIPT>
~;
				$jsload = qq~go('wbfolders','$scripturl?wbfolders');~;
				$jsload = qq~ onLoad="$jsload"~;
			}
			&WBSaveFolder( $wbcurdir, $ugchoice );
			$qstring = "ef$wbcurdir";
			$TBFootMessage .= qq~
Folder Filters for $wbcurdir have been saved.<BR><BR>
~;
		}

	}
	if( $qstring =~ /^ef(.*)/i ) {
		$wbcurdir = $1 || $in{'editfolder'};
		&WorkBenchHead("edit folder $wbcurdir",'left',$jscode,$jsload);
		&WorkBenchToolBar;
		unless( exists $wbdirhash{$wbcurdir} ) {
			&WBMessage(qq~The folder $wbcurdir does not exist for $ugchoice.
<BR>This error probably means that you are attempting to edit a group folder.
<BR>Only webmasters may edit group folders, and you must specifically switch to that group in order to do so.~);
		}
		else {
			print qq~<div align="center"><h3>Editing Folder $wbcurdir for $ugchoice</h3><BR>
<form action="$scripturl?wbtbsf" method="post">
<input type="hidden" name="ugselect" value="$ugchoice">
<input type="hidden" name="editfolder" value="$wbcurdir">
<table width="85%" cellspacing="5" cellpadding="5" bgcolor="#$wbtxc[2]" border="1" bordercolor="#$wbtxc[3]" align="center">
<tr><td valign="middle" align="center" colspan="2">
<BR><font size="+2">Folder Name:</font><BR><BR></td><td valign="middle" align="center">
<input type="text" size="20" name="dirdesig" value="$wbcurdir"></td></tr>
~;
			&WBLoadFolder( $wbcurdir );
			for( $wbfilternum = 0; $wbfilternum < @wbdirfilter; $wbfilternum++ ) {
				print qq~<tr>
<td valign="middle" align="center" width="20">
<input type="checkbox" name="fchk--$wbfilternum" checked><font size="-1">$wbfilternum</font></td>~;
				&{$WBFEdit{$wbdirfilter[$wbfilternum][0]}[0]}( @{$wbdirfilter[$wbfilternum][1]} );
				print q~</tr>~;
			}
			print qq~<tr><td valign="middle" align="center" colspan="2">
<BR><font size="+2">Create new filter:</font><BR><BR></td><td valign="middle" align="center">
<select name="newffilter">
<option value="">(create a new filter)</option>
~;
			foreach my $wbfiltername (sort keys %WBFilter) {
				print qq~<option value="$wbfiltername">$wbfiltername</option>~;
			}
			print qq~</select></td></tr>
<tr><td colspan="9" div align="center"><BR>
<h3>To remove a filter, deselect the checkbox to the left of that filter.</h3><BR>
<input type="submit" name="finedit" value="Apply Folder Filters"><BR>
</td></tr></table></form></div>~;
		}
	}
	elsif( $qstring =~ /^eaf(.*)/i ) {
		$qstring = $1;
		my( $jscode, $jsload );
		if( $in{'deletefolder'} || $in{'newfolder'} ) {
			$jscode = q~
<SCRIPT LANGUAGE="JavaScript">
<!--
function go(frame1,page1) {
eval("parent."+frame1+".location='"+page1+"'");
}
//-->
</SCRIPT>
~;
			$jsload = qq~go('wbfolders','$scripturl?wbfolders');~;
			$jsload .= qq~go('wbdesktop','$scripturl?wbdesktop$in{'newfolder'}');~ if( $in{'newfolder'} );
			$jsload = qq~ onLoad="$jsload"~;
		}
		&WorkBenchHead("manage folders",'left',$jscode,$jsload);
		&WorkBenchToolBar;
		if( $in{'deletefolder'} && ! ( $in{'NewFolderS'} || $in{'EditFolderS'} ) ) {
			$wbcurdir = $in{'deletefolder'};
			if( exists $wbdirhash{$wbcurdir} ) {
				print qq~<div align="center">
<h3>Folder $wbcurdir has been deleted.</h3>
<form action="$scripturl?wbf" target="wbf" method=post><BR><BR>
<font size="+2"><a href="" onclick="go('wbfolders','$scripturl?wbfolders');return false;">Refresh</a></font>
<input type="submit" name="refwbf" value="Refresh Folder List"><BR>
</form>
~;
				$wbfiltersloaded = 1;
				delete $wbdirhash{$wbcurdir};
				&WBWriteFolders( $ugchoice );
			}
			else {
				&WBMessage(qq~The folder $wbcurdir does not exist for $ugchoice.~);
			}
		}
		elsif( $in{'newfolder'} && ( ! $in{'EditFolderS'} ) ) {
			$wbcurdir = $in{'newfolder'};
			if( exists $wbdirhash{$wbcurdir} ) {
				&WBMessage(qq~The folder $wbcurdir already exists for $ugchoice.~);
			}
			else {
				print qq~<div align="center">
<h3>Folder $wbcurdir has been created.</h3>
<form action="$scripturl?wbf" target="wbf" method=post><BR><BR>
<input type="submit" name="refwbf" value="Refresh Folder List"><BR>
<font size="+2"><a href="" onclick="go('wbfolders','$scripturl?wbfolders');go('wbdesktop','$scripturl?wbdesktop$wbcurdir');return false;">refresh</a></font>
</form>
~;
				$wbfiltersloaded = 1;
				$wbdirhash{$wbcurdir} = '';
				&WBWriteFolders( $ugchoice );
			}
		}
		else {
			print qq~<div align="center">
<h3>Managing Folders for $ugchoice:</h3>
<table width="85%" cellspacing="5" cellpadding="5" bgcolor="$wbtxc[2]" bordercolor="$wbtxc[3]" border="1" align="center">
<tr><td align="center">
	<form action="$scripturl?wbtbeaf" method=post><BR><BR>
		Delete selected folder:
		<select name="deletefolder">
			<option value="">(select a folder to delete)</option>
			$wbdirselect
		</select>
		<input type="hidden" name="ugselect" value="$ugchoice">
		<input type="submit" name="DeleteFolderS" value="Delete">
	</form>
		<BR><BR><HR size="10">
	<form action="$scripturl?wbtbeaf" method=post><BR><BR>
		Create a new folder:
		<input type="text" name="newfolder" value="">
		<input type="hidden" name="ugselect" value="$ugchoice">
		<input type="submit" name="NewFolderS" value="New">
	</form>
		<BR><BR><HR size="10">
	<form action="$scripturl?wbtbef" method=post><BR><BR>
		Edit selected folder filter:
		<select name="editfolder">
			<option value="">(select a folder to edit)</option>
			$wbdirselect
		</select>
		<input type="hidden" name="ugselect" value="$ugchoice">
		<input type="submit" name="EditFolderS" value="Edit">
	</form>
		<BR><BR>
</td></tr>
</table></div>
~;
		}
	}
	if( $up > 2 ) {
		print qq~
<div align="center">
<form action="$scripturl?wbtbeaf" method=post><BR><BR>
	$ugselect
	<input type="submit" name="ugselbtn" value="Select User or Group to Manage">
</form>
</div>
~;
	}
	if( $TBFootMessage ) {
		print qq~
<div align="center"><table cellspacing="5" cellpadding="5" bgcolor="#$wbtxc[2]" border="1" bordercolor="#$wbtxc[3]"><tr><td align="center"><font size="+2"><BR>
$TBFootMessage~ . q~<HR>Time Stamp: ~ . time() . q~<BR></font></td></tr></table></div>~;
	}
	&WorkBenchFoot;
	exit;
}

##############################################
# Handle editing of settings.
#	invocation: &WorkBenchSettings;
#
sub WorkBenchSettings {
	my ( $ugselect, $ugchoice, %ugsel, @groups, $group );
	if( $in{'ugselect'} && $up > 2 ) {
		$ugchoice = $in{'ugselect'};
		unless( exists $CPassword{$ugchoice} || exists $usergroups{$ugchoice} ) {
			$ugchoice = '';
		}
	}
	$ugchoice ||= $Cookies{'uname'};
	$ugsel{$ugchoice} = 'selected';
	@groups = sort keys %CPassword;
	foreach $group (sort keys %usergroups) {
		unless( $CPassword{$group} ) {
			push( @groups, $group );
		}
	}
	if( $up > 2 ) {
		$ugselect = '<select name="ugselect">\n';
		foreach $group (@groups) {
			$ugselect .= qq~<option value="$group" $ugsel{$group}>$group</option>\n~;
		}
	}
	else {
		$ugselect = qq~<input type="hidden" name="ugselect" value="">~;
	}
	&WorkBenchHead("edit workbench settings for $ugchoice",'left');
	&WorkBenchToolBar;
	my ( $counter, $i, @colornames, $changecolor  );
	my ( $fview, $fcol, @fvfield ) = split( /\W/, &ugVar( $ugchoice, 'WBFVS' ) );
	my $fvfield = join( ';', @fvfield );
	$fview = $in{'esfv'} || $fview || 'DisplayNewsDetails';
	$fcol = $in{'esfc'} || $fcol || 3;
	( $i = $in{'esff'} ) =~ s~\W~;~g;
	$fvfield = $i || $fvfield || q~newssubject;newsdate;newsname~;
	$ispreview = $in{'wbespreview'} ? 1 : 0;
	my @txc = split( /\W/, &ugVar( $ugchoice, 'WBTXC' ) );
	unless( @txc == 11 ) {
			@txc = ( 'ffc477', '77ff66', '262424', '7a7a7c', '4682b4', '6a5acd', 'ff0000', 'ffffff', '000000', '333333', '555555' );
	}
	if( $in{'wbessubmit'} ) {
		if( $in{'wbcolorwipe'} ) {
			&ugVarSetValue( $ugchoice, 'WBTXC' );
		}
		else {
			for( $i = 0; $i < @txc; $i++ ) {
				$txc[$i] = $in{"wbsc$i"} || $txc[$i];
			}
			$_ = join( ',', @txc );
			&ugVarSetValue( $ugchoice, 'WBTXC', $_ );
		}
		$_ = join( ';', ( $fview, $fcol, $fvfield ) );
		&ugVarSetValue( $ugchoice, 'WBFVS', $_ );
		&UserGroupsSaveConfig;
		&WBMessage( qq~Thank you. Settings for $ugchoice have been saved.~ );
		&WorkBenchFoot;
		exit;
	}
	@colornames = ( 'text', 'icon color', 'table BG', 'table border', 'link', 'visited', 'active', 'hover', 'body', 'row color 1', 'row color 2' );
	print qq~
<div align="center">
<h2>Edit WorkBench Settings for $ugchoice</h2>
<h3>Please select your desired colors for workbench.</h3>
<form action="$scripturl?wbes" method=post><BR><BR>
<input type="hidden" name="ugselect" value="$ugchoice">
<table width="75%" cellspacing="1" cellpadding="5" border="1" align="center">
~;
	$counter = 1;
	for( $i = 0; $i < @txc; $i++ ) {
		$changecolor = $ispreview ? $in{"wbsc$i"} : $txc[$i];
		print qq~
		<td width="64">#$txc[$i]</td>
		<td width="100">$colornames[$i]</td>
		<td bgcolor="#$txc[$i]">&nbsp&nbsp&nbsp</td>
		<td bgcolor="#$changecolor" id="WBSC$i">&nbsp&nbsp&nbsp</td>
		<td>
			<input type="text" name="wbsc$i" value="$changecolor" size="8" maxlength="6"
				onChange="document.all.WBSC$i.bgColor=(wbsc$i.value)">
		</td>
		~;
		$counter++;
		if( $counter % 2 ) { print "</tr><tr>"; }
	}
	print q~</table><br><br>
<input type="submit" name="wbespreview" value="PREVIEW"><br>
Netscape users must click here to PREVIEW colors<br><br><br>
<br><hr size="3"><br>
~;
	my ( $key, $val, $sel );
	print q~
<h3>Please specify your folder view settings.</h3>
<table width="75%" cellspacing="1" cellpadding="5" border="1" align="center">
<tr>
	<td>
		Please select the viewer you wish to use.
	</td>
	<td>
		<select name="esfv">
~;
	while( ($key,$val) = (each %WBFViewer) ) {
		$sel = $fview eq $key ? 'selected' : '';
		print qq~<option value="$key" $sel>$val</option>~;
	}
	print qq~
		</select>
	</td>
</tr>
<tr>
	<td>
		Please select the number of columns to use, if appropriate.<BR>
		Some views do not make use of this setting.
	</td>
	<td>
		<input type="text" name="esfc" size="6" maxlength="5" value="$fcol">
	</td>
</tr>
<tr>
	<td>
		Please specify fields to display.<BR>
		Separate fields with semicolons or commas.
	</td>
	<td>
		<input type="text" name="esff" size="40" value="$fvfield">
	</td>
</tr>
~;
	
	print q~</table><br><br>
<input type="submit" name="wbessubmit" value="Save Changes">
<input type="submit" name="wbesreset" value="Reset All"><BR><BR>
<input type="checkbox" name="wbcolorwipe" value="1">Clear This User/Group's Custom Colors?<BR>
(be careful - doing so could make people angry)
</form></div>
~;
	if( $up > 2 ) {
		print qq~
<div align="center">
<form action="$scripturl?wbes" method=post><BR><BR>
	$ugselect
	<input type="submit" name="ugselbtn" value="Select User or Group to Manage">
</form>
</div>
~;
	}
	&WorkBenchFoot;
	exit;
}

##############################################
# Handle all WorkBench functionality.
#	invocation: &WorkBenchMain("query string, minus the leading 'wb' part.");
#
sub WorkBenchMain {
	my $qstring = shift;
	$qstring =~ s/%20/ /g;
	if(@Addons_WBPageHandler) {
		&RunAddons(@Addons_WBPageHandler);
	}
	if( $qstring =~ /^tb(.*)/i ) {
		&WBToolBarMain( $1 );
	}
	elsif( $qstring eq "debug" ) {
		print header();
		&NPHTMLHead('WorkBench Debugger');
		while( ($key, $val) = (each %ENV) ) {
			print &HTMLescape(qq~$key ===== $val~);
			print '<br>';
		}
		&NPHTMLFoot;
		exit;
	}
	elsif( $qstring eq 'f' ) {
		&WorkBenchIndex;
	}
	elsif( $qstring eq 'folders' ) {
		&WorkBenchFolders;
	}
	elsif( $qstring =~ /^desktop(.*)/i ) {
		&WorkBenchDesktop( $1 );
	}
	elsif( $qstring =~ /^editmul.*/i ) {
		( $_ = $in{'acton'} ) =~ s/x/\,/g;
		@_ = split( /\|,\|/, $_ );
		if( $in{'editmul'} ) {
			&WBEdit( @_ );
			exit;
		}
		%WBNDSel = ();
		foreach (@_) {
			$WBNDSel{$_} = 1;
		}
		push(@Addons_loadND_1, 'WB_loadND_1');
		push(@Addons_loadND_2, 'WB_loadND_2');
		if( $in{'forcedelmul'} && $in{'delmul'} ) {
			&WBDelete;
		}
		elsif( $in{'delmul'} ) {
			&WorkBenchDesktop( $in{'wbcurdir'} );
		}
	}
	elsif( $qstring =~ /^editem(.*)/i ) {
		( $_ = $1 ) =~ s/x/\,/g;
		&WBEdit( $_ );
		exit;
	}
	elsif( $qstring =~ /^es(.*)/i ) {
		&WorkBenchSettings( $1 );
	}
}

##############################################
# Handle mass deletion of newsitems, with a confirmation page.
#	invocation: &WBDelete;
#
sub WBDelete {
	&loadND;
	&SubmitFormFields;
	$FormFieldsModifySize{'newstext'} = 1;
	&WorkBenchHead('Deleting NewsItems', 'left' );
	print q~<h3>Below are the news items which are being deleted. You may want to save this HTML page, which contains the values of all the fields of the deleted news item, if you determine that you have made a mistake in deleting any of these news items.</h3>(some fields may not be relevant when resubmitting the newsitem)<br><hr><br>~;
	my( $dnum, $ff, $escapedfield );
	for( my $nn = 0; $nn < @NewsData; $nn++ ) {
		unless ($up >= 2 || $NewsData[$nn]->{'newsname'} eq $Cookies{'uname'}) { next; }
		if( $NewsData[$nn]->{'wbwb_issel'} == 1 ) {
			print qq~<ul><font size="+2">$NewsData[$nn]->{'newssubject'}</font> : $NewsData[$nn]->{'newsid'}<br>~;
			foreach $ff (keys %{$NewsData[$nn]}) {
				$escapedfield = HTMLescape( $NewsData[$nn]->{$ff} );
				if ($FormFieldsName{$ff}) {
					print qq~<li><b>$FormFieldsName{$ff}</b>~;
				} else {
					print qq~<li><b>$ff</b>~;
				}
				if ($FormFieldsModifySize{$ff}) {
					if ($FormFieldsNewlines{$ff}) {
						$escapedfield =~ s/\&lt;br\&gt;/\n/gi;
					}
					print qq~ <textarea name="$ff---$dnum" wrap="virtual" cols="70" rows="7" wrap="virtual">$escapedfield</textarea><br> ~;
				}
				else {
					print qq~: <input type="text" name="$ff---$dnum" value="$escapedfield" size="40"><br>~;
				}
				print qq~</li>~;
			}
			print q~</ul><hr>~;
			$NewsData[$nn] = 'del';
			$dnum++;
		}
	}
	&saveND;
	print q~</body></html>~;
	exit;
}

##############################################
# Prepare to give each newsitem as "selected" field, for use with editing/deleting
#	invocation: &WB_loadND_1;
#
sub WB_loadND_1 {
	push( @ffield_add, 'wbwb_issel' );
}

##############################################
# Give each newsitem as "selected" field, for use with editing/deleting
#	invocation: &WB_loadND_2;
#
sub WB_loadND_2 {
	$wbwb_issel = $WBNDSel{$newsid};
}

##############################################
# Print the link to WorkBench on the NewsPro main page
#	invocation: &WorkBench_MainPage();
#
sub WorkBench_MainPage {
	print qq~
	<a target="_blank" href="$scripturl?wbf"><b>WorkBench</a>:</b>
	"We like to party." by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a>
	<br><br>
	~;
}

##############################################
# Print the link to WorkBench in the NewsPro footer
#	invocation: &WorkBench_HTMLFoot();
#
sub WorkBench_HTMLFoot {
	print qq~ \n<a target="_blank" href="$scripturl?wbf" class="navlink">WorkBench</a> |~;
}

##############################################
# Split the specified user's WBDIR variable into a list of folders.
#	invocation: &WBReadFolders( "1 for all folders (includes inherited) / 0 for only user-specific folders", "user" );
#
sub WBReadFolders {
	my ( $wbdirname, $wbdirfilter, $wbfoldernum );
	my( $uorg, $ugchoice ) = @_;
	$ugchoice ||= $Cookies{'uname'};
	@wbdirlist = sort split( /\|x\|/, ( $uorg ? inheritedVar( $ugchoice, 'WBDIR' ) : ugVar( $ugchoice, 'WBDIR' ) ) );
	%wbdirhash = ();
	for( $wbfoldernum = 0; $wbfoldernum < @wbdirlist; $wbfoldernum++ ) {
		( $wbdirname, $wbdirfilter ) = $wbdirlist[$wbfoldernum] =~ m~(.+)=(.*)~;
		$wbdirhash{$wbdirname} = $wbdirfilter;
	}
	$wbdirsloaded = 1;
}

##############################################
# Load the specified folder's filters into memory with their arguments.
#	invocation: &WBLoadFolder("folder name");
#
sub WBLoadFolder {
	unless( $wbdirsloaded ) { &WBReadFolders; }
	my $wbcurdir = $_[0];
	my( $wbfilternum, $wbfiltername, @wbfilterargs );
	unless( exists $wbdirhash{$wbcurdir} ) { return; }
	@wbdirfilter = split( /\<x\>/, $wbdirhash{$wbcurdir} );
	for( $wbfilternum = 0; $wbfilternum < @wbdirfilter; $wbfilternum++ ) {
		( $wbfiltername, @wbfilterargs ) = split( /;/, $wbdirfilter[$wbfilternum] );
		$wbdirfilter[$wbfilternum] = [ $wbfiltername, [@wbfilterargs] ];
	}
	$wbfiltersloaded = 1;
}

##############################################
# Prepare a folder for saving to disk by combining it into one string.
#	invocation: &WBJoinFolder("folder name", "user");
#
sub WBJoinFolder {
	unless( $wbdirsloaded && $wbfiltersloaded ) { return; }
	my( $wbcurdir, $ugchoice ) = @_;
	$ugchoice ||= $Cookies{'uname'};
	my @newdirfilter;
	for( my $wbfilternum = 0; $wbfilternum < @wbdirfilter; $wbfilternum++ ) {
		$newdirfilter[$wbfilternum] = $wbdirfilter[$wbfilternum][0] . ';' . join( ';', @{$wbdirfilter[$wbfilternum][1]} );
	}
	$wbdirhash{$wbcurdir} = join( '<x>', @newdirfilter );
}

##############################################
# Save all folders for the specified user to disk.
#	invocation: &WBWriteFolders("user");
#
sub WBWriteFolders {
	unless( $wbdirsloaded && $wbfiltersloaded ) { return; }
	my $ugchoice = shift || $Cookies{'uname'};
	@wbdirlist = ();
	while( ($key,$val) = (each %wbdirhash) ) {
		push( @wbdirlist, qq~$key=$val~ );
	}
	$_ = join( '|x|', @wbdirlist );
	&ugVarSetValue( $ugchoice, 'WBDIR', $_ );
	&UserGroupsSaveConfig;
}

##############################################
# Assemble the specified folder for the specified user. Save to disk.
#	invocation: &WBSaveFolder("folder name", "user");
#
sub WBSaveFolder {
	unless( $wbdirsloaded && $wbfiltersloaded ) { return; }
	my( $wbcurdir, $ugchoice ) = @_;
	$ugchoice ||= $Cookies{'uname'};
	&WBJoinFolder( $wbcurdir, $ugchoice );
	&WBWriteFolders( $ugchoice );
}
1;